-- /run for i=1,40 do local name, _, icon, count, type, duration, exp, unitCaster, isStealable, _, spellId=UnitBuff("player",i); if name then type=debuffType or "other"; print(unitCaster.." "..type.." "..count.." "..name.." = "..spellId) end end
-- /run for i=1,40 do local name, rank, icon, count, debuffType, duration, expirationTime, unitCaster, isStealable, shouldConsolidate, spellId=UnitDebuff("target",i); if name then print(name.."="..spellId) end end
-- /run for i=1,40 do local name, rank, icon, count, debuffType, duration, expirationTime, unitCaster, isStealable, shouldConsolidate, spellId=UnitBuff("pet",i); if name then print(count.." "..name.."("..expirationTime..")".." = "..spellId) end end
-- get the addon namespace
local addon, ns = ...
-- get the config values
local cfg = ns.cfg
-- holder for some lib functions
local lib = _G["HEDD_lib"] or CreateFrame("Frame","HEDD_lib")
ns.lib = lib

lib.SetTrackDOT = function(aura,maxtick,spell,num_show,notext)
	if cfg.aura[aura] then
		if notext then
			Heddmain.DOT.text:Hide()
		else
			Heddmain.DOT.text:Show()
		end
		cfg.TrackDOT.maxtick=maxtick or cfg.TrackDOT.maxtick
		cfg.TrackDOT.num_show=num_show or 1
		cfg.TrackDOT.aura=aura
		
		cfg.TrackDOT.id=cfg.aura[aura].id
		if spell and cfg.spells[spell] then
			cfg.TrackDOT.spell=spell
			Heddmain.DOT.texture:SetTexture(cfg.spells[spell].icon)
			lib.SetSpellFunction(cfg.TrackDOT.spell,"OnUpdate",function()
				if Heddmain.DOT.texture:IsShown() and cfg.spells[cfg.TrackDOT.spell].cd>0 then
					CooldownFrame_SetTimer(Heddmain.DOT.cooldown,cfg.spells[cfg.TrackDOT.spell].start,cfg.spells[cfg.TrackDOT.spell].cd,1)
				else
					Heddmain.DOT.cooldown:Hide()
				end
			end)
		else
			cfg.TrackDOT.spell=nil
			Heddmain.DOT.texture:SetTexture(cfg.aura[aura].icon)
			lib.SetAuraFunction(cfg.TrackDOT.aura,"OnApply",function()
				Heddmain.DOT.cooldown:Show()
				CooldownFrame_SetTimer(Heddmain.DOT.cooldown,cfg.aura[cfg.TrackDOT.aura].expire-cfg.aura[cfg.TrackDOT.aura].duration, cfg.aura[cfg.TrackDOT.aura].duration,1)
			end)
			lib.SetAuraFunction(cfg.TrackDOT.aura,"OnFade",function()
				Heddmain.DOT.cooldown:Hide()
				--CooldownFrame_SetTimer(Heddmain.DOT.cooldown,cfg.aura[cfg.TrackDOT.aura].expire-cfg.aura[cfg.TrackDOT.aura].duration, cfg.aura[cfg.TrackDOT.aura].duration,1)
			end)
		end
		Heddmain.DOT:Show()
		Heddmain.DOT:SetScript("OnUpdate", lib.OnUpdateTrackDOT)
		lib.UpdateTrackDOT()
		lib.UpdateTrackDOTFrame()
		lib.SetAuraFunction(cfg.TrackDOT.aura,"OnStacks",function()
			if cfg.aura[cfg.TrackDOT.aura].stacks>1 then
				Heddmain.DOT.stacks:SetText(cfg.aura[cfg.TrackDOT.aura].stacks)
			else
				Heddmain.DOT.stacks:SetText("")
			end
		end)
	else
		Heddmain.DOT:Hide()
		Heddmain.DOT:SetScript("OnUpdate", nil)
	end
end

lib.AddTrackDOT = function(guid)
	cfg.TrackDOT.targets[guid]=GetTime()
	lib.UpdateTrackDOT()
end

lib.DelTrackDOT = function(guid)
	cfg.TrackDOT.targets[guid]=nil
	lib.UpdateTrackDOT()
end

lib.ClearTrackDOT = function()
	cfg.TrackDOT.targets={}
	lib.UpdateTrackDOT()
end

local pDOTS
lib.UpdateTrackDOT = function()
	pDOTS=cfg.TrackDOT.num
	cfg.TrackDOT.num=0
	for guid,value in pairs(cfg.TrackDOT.targets) do
		if GetTime()>(cfg.TrackDOT.targets[guid]+cfg.TrackDOT.maxtick+select(4,GetNetStats())/1000) then
			cfg.TrackDOT.targets[guid]=nil
		else
			cfg.TrackDOT.num=cfg.TrackDOT.num+1
		end
	end
	if pDOTS~=cfg.TrackDOT.num then cfg.TrackDOT.Update=true end
end

lib.UpdateTrackDOTFrame = function()
	if HeddDB.DOT=="hide" then
		Heddmain.DOT:Hide()
		return
	else
		Heddmain.DOT:Show()
	end
	if not cfg.TrackDOT then return end
	if cfg.TrackDOT.spell then
		if cfg.TrackDOT.num>=cfg.TrackDOT.num_show then
			lib.ShowTrackDOT()
			return
		end
	else
		if cfg.TrackDOT.num>=cfg.TrackDOT.num_show or (cfg.aura[cfg.TrackDOT.aura] and cfg.aura[cfg.TrackDOT.aura].present==1) then
			lib.ShowTrackDOT()
			return
		end
	end
	lib.HideTrackDOT()
end

lib.OnUpdateTrackDOT = function (self, elapsed)
	elapsed = elapsed or 0
	cfg.TrackDOT.lastUpdate = cfg.TrackDOT.lastUpdate + elapsed
	if cfg.TrackDOT.lastUpdate > cfg.TrackDOT.maxtick then --cfg.freq
		lib.UpdateTrackDOT()
	end
	if cfg.TrackDOT.Update then
		lib.UpdateTrackDOTFrame()
		cfg.TrackDOT.lastUpdate = 0
		cfg.TrackDOT.Update=false
		cfg.Update=true
	end	
end

lib.ShowTrackDOT=function()
	if cfg.TrackDOT.num>0 then
		Heddmain.DOT.texture:Show()
		Heddmain.DOT.text:SetText(cfg.TrackDOT.num)
	else
		lib.HideTrackDOT()
	end
	--print(cfg.TrackDOT.num)
	--print("Show")
end

lib.HideTrackDOT=function()
	--print("Hide")
	Heddmain.DOT.texture:Hide()
	Heddmain.DOT.text:SetText("")
	Heddmain.DOT.stacks:SetText("")
	Heddmain.DOT.cooldown:Hide()
end

lib.SetTrackAura = function(spell,maxbuffs)
	if cfg.aura[spell] then
		maxbuffs=maxbuffs or 0
		cfg.TrackAura.aura=spell
		cfg.TrackAura.unit=cfg.aura[spell].unit
		cfg.TrackAura.max=maxbuffs
		Heddmain.Aura.texture:SetTexture(cfg.aura[spell].icon)
		lib.UpdateAuraFrame()
	else
		Heddmain.Aura:Hide()
	end
end

local pBUFF
lib.UpdateTrackAura=function(guid,num)
	pBUFF=cfg.TrackAura.targets[guid]
	if num then
		cfg.TrackAura.targets[guid]=num
	else
		cfg.TrackAura.targets[guid]=nil
	end
	if pBUFF~=cfg.TrackAura.targets[guid] or cfg.aura[cfg.TrackAura.aura].reapply then
		lib.UpdateAuraFrame()
	end
end

lib.GetTrackAura=function()
	if cfg.TrackAura.aura and lib.GetAura({cfg.TrackAura.aura})>0 then
		return cfg.TrackAura.targets[cfg.GUID[cfg.TrackAura.unit]] or -1
	end
	return -1
end

local guid
lib.UpdateAuraFrame=function()
	--if not cfg.TrackAura then return nil end
	
	if not cfg.TrackAura.aura then
		Heddmain.Aura:Hide()
		return
	end
	
	if HeddDB.Aura=="hide" then
		Heddmain.Aura:Hide()
		return
	else
		Heddmain.Aura:Show()
	end

	if cfg.GUID[cfg.TrackAura.unit] and cfg.TrackAura.targets[cfg.GUID[cfg.TrackAura.unit]] and lib.GetAura({cfg.TrackAura.aura})>0 then
		Heddmain.Aura:Show()
		CooldownFrame_SetTimer(Heddmain.Aura.cooldown,cfg.aura[cfg.TrackAura.aura].expire-cfg.aura[cfg.TrackAura.aura].duration, cfg.aura[cfg.TrackAura.aura].duration,1)
		if cfg.TrackAura.max>0 then
			Heddmain.Aura.text:SetText(cfg.TrackAura.targets[cfg.GUID[cfg.TrackAura.unit]].."/"..cfg.TrackAura.max)
		else
			Heddmain.Aura.text:SetText(cfg.TrackAura.targets[cfg.GUID[cfg.TrackAura.unit]]>1 and cfg.TrackAura.targets[cfg.GUID[cfg.TrackAura.unit]] or " ")
		end
	else
		Heddmain.Aura:Hide()
	end
end

lib.AddAura = function(spell,id,atype,unit,caster) --,onchange
	if not lib.Hedd_GSI(id) then 
		--print("Warning!!! Aura \""..spell.."\" with id="..id.." is not in game!")
		return
	end
	
	atype=atype or "buff"
	if atype=="buff" then
		unit=unit or "player"
	else
		unit=unit or "target"
	end
	caster=caster or "player"
	
	cfg.watchunits[unit]=true
	cfg.aura_unit_id[unit] = cfg.aura_unit_id[unit] or {}
	
	if cfg.aura[spell] and cfg.aura[spell].id~=id then
		cfg.id2aura[cfg.aura[spell].id]=nil
		cfg.aura_seen[cfg.aura[spell].id]=nil
		cfg.aura_unit_id[unit][cfg.aura[spell].id]=nil
	end
	if cfg.id2aura[id] then
		cfg.aura[spell]=cfg.aura[cfg.id2aura[id]]
		return
	end
	
	cfg.aura[spell] = cfg.aura[spell] or {}
	
	cfg.aura_unit_id[unit][id] = cfg.aura[spell]
	cfg.id2aura[id] = spell
	
	cfg.aura[spell].id=id
	cfg.aura[spell].name,_,cfg.aura[spell].icon = GetSpellInfo(id)
	if cfg.release>6 then
		cfg.aura[spell].icon = GetSpellTexture(id)
	end
	cfg.aura[spell].spell = spell
	cfg.aura[spell].duration=0
	cfg.aura[spell].expire=0
	cfg.aura[spell].stacks=0
	cfg.aura[spell].powerType=atype
	cfg.aura[spell].unit=unit
	cfg.aura[spell].caster=caster
	cfg.aura[spell].real_caster=nil
	cfg.aura[spell].present=0
	cfg.aura[spell].faded=0
	cfg.aura[spell].pstacks=0
	cfg.aura[spell].apply=false
	cfg.aura[spell].reapply=false
	cfg.aura[spell].fade=false
	cfg.aura_seen[id]=0
	--cfg.aura_found[unit]=cfg.aura_found[unit] or {}
	--cfg.aura_found[unit][id]=false
	--print("Adding "..cfg.aura[spell].name)
	--lib.UpdateAura(spell)
end

--[[lib.ChangeAuraId = function(spell,id,condition)
	if cfg.aura[spell] and condition then
		cfg.aura[spell].id=id
		lib.UpdateSpell(spell)
		return true
	end
	return false
end]]

lib.SetAuraFunction = function(spell,event,func)
	if cfg.aura[spell] then
		if event=="OnApply" then
			cfg.aura[spell].OnApply=cfg.aura[spell].OnApply or {}
			table.insert(cfg.aura[spell].OnApply,#cfg.aura[spell].OnApply+1,func)
			
			cfg.aura[spell].OnReApply=cfg.aura[spell].OnReApply or {}
			table.insert(cfg.aura[spell].OnReApply,#cfg.aura[spell].OnReApply+1,func)
			return #cfg.aura[spell].OnApply
		end
		if event=="OnReApply" then
			cfg.aura[spell].OnReApply=cfg.aura[spell].OnReApply or {}
			table.insert(cfg.aura[spell].OnReApply,#cfg.aura[spell].OnReApply+1,func)
			return #cfg.aura[spell].OnReApply
		end
		if event=="OnFade" then
			cfg.aura[spell].OnFade=cfg.aura[spell].OnFade or {}
			table.insert(cfg.aura[spell].OnFade,#cfg.aura[spell].OnFade+1,func)
			return #cfg.aura[spell].OnFade
		end
		if event=="OnStacks" then
			cfg.aura[spell].OnStacks=cfg.aura[spell].OnStacks or {}
			table.insert(cfg.aura[spell].OnStacks,#cfg.aura[spell].OnStacks+1,func)
			return #cfg.aura[spell].OnStacks
		end
		if event=="OnValue1" then
			cfg.aura[spell].OnValue1=cfg.aura[spell].OnValue1 or {}
			table.insert(cfg.aura[spell].OnValue1,#cfg.aura[spell].OnValue1+1,func)
			return #cfg.aura[spell].OnValue1
		end
		if event=="OnValue2" then
			cfg.aura[spell].OnValue2=cfg.aura[spell].OnValue2 or {}
			table.insert(cfg.aura[spell].OnValue2,#cfg.aura[spell].OnValue2+1,func)
			return #cfg.aura[spell].OnValue2
		end
		if event=="OnValue3" then
			cfg.aura[spell].OnValue3=cfg.aura[spell].OnValue3 or {}
			table.insert(cfg.aura[spell].OnValue3,#cfg.aura[spell].OnValue3+1,func)
			return #cfg.aura[spell].OnValue3
		end
		
	end
end

lib.AddAuras = function(spell,ids,atype,unit,caster)
	if atype=="buff" then
		unit=unit or "player"
	else
		atype="debuff"
		unit=unit or "target"
	end
	caster = caster or "any"
	cfg.auras[spell]=cfg.auras[spell] or {}
	for index,id in ipairs(ids) do
		lib.AddAura(spell..index,id,atype,unit,caster)
		if cfg.aura[spell..index] then
			table.insert(cfg.auras[spell],spell..index)
		end
	end
end

lib.AddAurasAlias = function(spell,auras)
	cfg.auras[spell]=cfg.auras[spell] or {}
	for index,aura in ipairs(auras) do
		if cfg.aura[aura] then
			cfg.aura[spell..index]=cfg.aura[aura]
			table.insert(cfg.auras[spell],spell..index)
		end
	end
end

local auras_old={}
local aname, acount, adispelType, aduration, aexpirationTime, aunitCaster, aid
local spell
local UpdateAuraId
local UpdateAura_time=0
local aura_unit

local Aura_NO = function(unit,id)
	cfg.aura_unit_id[unit][id].duration=0
	cfg.aura_unit_id[unit][id].expire=0
	cfg.aura_unit_id[unit][id].stacks=0
	cfg.aura_unit_id[unit][id].present=0
	cfg.aura_unit_id[unit][id].real_caster=nil
	cfg.aura_unit_id[unit][id].value1=nil
	cfg.aura_unit_id[unit][id].value2=nil
	cfg.aura_unit_id[unit][id].value3=nil
end

local Aura_YES = function(unit,id,duration,expire,stacks,caster,value1, value2, value3)
	if duration==expire and duration==0 then
		cfg.aura_unit_id[unit][id].duration=9999
		cfg.aura_unit_id[unit][id].expire=GetTime()+9999
	else
		cfg.aura_unit_id[unit][id].duration=duration
		cfg.aura_unit_id[unit][id].expire=expire
	end
	cfg.aura_unit_id[unit][id].stacks=stacks or 1
	cfg.aura_unit_id[unit][id].stacks=cfg.aura_unit_id[unit][id].stacks==0 and 1 or cfg.aura_unit_id[unit][id].stacks
	cfg.aura_unit_id[unit][id].present=1
	cfg.aura_unit_id[unit][id].real_caster=caster
	cfg.aura_unit_id[unit][id].value1=value1
	cfg.aura_unit_id[unit][id].value2=value2
	cfg.aura_unit_id[unit][id].value3=value3
end

lib.UpdateAuraAll = function(unit)
	if not cfg.watchunits[unit] then return end

	UpdateAura_time=GetTime()
	--print("Updating auras on "..unit)
	
	if cfg.dispell[unit] and cfg.dispell[unit].spell then
		cfg.dispell[unit].now=false
	end
	
	if not UnitExists(unit) and cfg.aura_unit_id[unit] then
		for aid,_ in pairs(cfg.aura_unit_id[unit]) do
			hedlib.shallowCopy(cfg.aura_unit_id[unit][aid],auras_old)
			Aura_NO(unit,aid)
			lib.IsAuraChanged(cfg.aura_unit_id[unit][aid],auras_old)
		end
		return
	end
	
	--buffs
	for i=1,40 do
		aname, _, _, acount, adispelType, aduration, aexpirationTime, aunitCaster, _, _, aid, canApplyAura, isBossDebuff, _,value1, value2, value3 = UnitAura(unit,i,"HELPFUL")
		if aid then
			adispelType=adispelType or "Other"
			if hedlib.enrage[aid] then adispelType="Enrage" end
			if unit=="target" and cfg.dispell[unit] and cfg.dispell[unit].spell and cfg.dispell[unit].powerType[adispelType] then
				cfg.dispell[unit].now=true
			end
			if cfg.aura_unit_id[unit] and cfg.aura_unit_id[unit][aid] then
				if cfg.aura_unit_id[unit][aid].caster==aunitCaster or cfg.aura_unit_id[unit][aid].caster=="any" then
					hedlib.shallowCopy(cfg.aura_unit_id[unit][aid],auras_old)
					Aura_YES(unit,aid,aduration,aexpirationTime,acount,aunitCaster,value1, value2, value3)
					cfg.aura_seen[aid]=UpdateAura_time
					lib.IsAuraChanged(cfg.aura_unit_id[unit][aid],auras_old)
				end
			end
		end
	end
	
	--debuffs
	for i=1,40 do
		aname, _, _, acount, adispelType, aduration, aexpirationTime, aunitCaster, _, _, aid, _,value1, value2, value3  = UnitAura(unit,i,"HARMFUL")
		if aid then
			adispelType=adispelType or "Other"
			if hedlib.enrage[aid] then adispelType="Enrage" end
			if unit=="player" and cfg.dispell[unit] and cfg.dispell[unit].spell and cfg.dispell[unit].powerType[adispelType] then
				cfg.dispell[unit].now=true
			end
			if cfg.aura_unit_id[unit] and cfg.aura_unit_id[unit][aid] then
				if cfg.aura_unit_id[unit][aid].caster==aunitCaster or cfg.aura_unit_id[unit][aid].caster=="any" then
					hedlib.shallowCopy(cfg.aura_unit_id[unit][aid],auras_old)
					Aura_YES(unit,aid,aduration,aexpirationTime,acount,aunitCaster,value1, value2, value3)
					cfg.aura_seen[aid]=UpdateAura_time
					lib.IsAuraChanged(cfg.aura_unit_id[unit][aid],auras_old)
				end
			end
		end
	end
	
	if cfg.aura_unit_id[unit] then
		for aid,_ in pairs(cfg.aura_unit_id[unit]) do
			if cfg.aura_seen[aid]<UpdateAura_time then
				--print("Cleaning! "..unit.." "..cfg.id2aura[aid])
				hedlib.shallowCopy(cfg.aura_unit_id[unit][aid],auras_old)
				Aura_NO(unit,aid)
				lib.IsAuraChanged(cfg.aura_unit_id[unit][aid],auras_old)
			end
		end
	end
	
	if cfg.dispell[unit] and cfg.dispell[unit].now then cfg.Update=true end
end

local aura_msg=nil
local change,key
lib.IsAuraChanged = function(aura,aura_old)
	--if not hedlib.ArrayNotChanged(aura,aura_old) then
	change,key=hedlib.shallowCompare(aura,aura_old)
	change=not change
	if change then
		aura_msg="Updating "..aura.spell
		if (aura_old.duration>0 and aura.duration==0) or (aura_old.present==1 and aura.present==0) then
			aura.pstacks=aura_old.stacks
			aura.faded=GetTime()
			aura.apply=false
			aura.reapply=false
			aura.fade=true
			aura_msg=aura_msg.." Fading"
			if aura.OnFade then
				for num_func,func in pairs(aura.OnFade) do
					func(num_func)
				end
			end
		elseif (aura_old.duration==0 and aura.duration>0) or (aura_old.present==0 and aura.present==1) then
			aura.apply=true
			aura.reapply=false
			aura.fade=false
			aura_msg=aura_msg.." Appling"
			if aura.OnApply then
				for num_func,func in pairs(aura.OnApply) do
					func(num_func)
				end
			end
		elseif aura_old.expire<aura.expire or aura_old.stacks~=aura.stacks or (aura_old.present==1 and aura.present==1) then
			aura.apply=false
			aura.reapply=true
			aura.fade=false
			aura_msg=aura_msg.." Reappling"
			if aura.OnReApply then
				for num_func,func in pairs(aura.OnReApply) do
					func(num_func)
				end
			end
		end
		if aura_old.stacks~=aura.stacks and aura.OnStacks then
			for num_func,func in pairs(aura.OnStacks) do
				func(num_func)
			end
		end
		
		if aura_old.value1~=aura.value1 and aura.OnValue1 then
			for num_func,func in pairs(aura.OnValue1) do
				func(num_func)
			end
		end
		
		if aura_old.value2~=aura.value2 and aura.OnValue2 then
			for num_func,func in pairs(aura.OnValue2) do
				func(num_func)
			end
		end
		if aura_old.value3~=aura.value3 and aura.OnValue3 then
			for num_func,func in pairs(aura.OnValue3) do
				func(num_func)
			end
		end
		if cfg.debugauras then
			--if aura_msg=="Updating "..aura.spell then
				print(aura_msg.." changed "..key.." "..aura_old[key].." "..aura[key])
			--else
--				print(aura_msg)
			--end 
		end
		cfg.Update=true
		return true
	else
		return false
	end
end



--Curse
--Disease
--Magic
--Poison
--Enrage
local buffs=nil
lib.CheckBuff = function(unit, bufftype)
	bufftype=bufftype or {"Magic"}
	if not buffs then
		buffs={}
		for _,id in ipairs(bufftype) do
			buffs[id]=true
		end
	end
	for i=1,40 do
		local name, _, _, _, b_type, _, _, _, _, _, spellId=UnitBuff(unit,i)
		if name then
			b_type=b_type or "Other"
			if hedlib.enrage[spellId] then b_type="Enrage" end
			if buffs[b_type] then
				return true
			end
		end
	end
	return nil
end

local debuffs=nil
lib.CheckDebuff = function(unit, bufftype)
	bufftype=bufftype or {"Magic"}
	if not debuffs then
		debuffs={}
		for _,id in ipairs(bufftype) do
			debuffs[id]=true
		end
	end
	for i=1,40 do
		local name, _, _, _, b_type, _, _, _, _, _, spellId=UnitDebuff(unit,i)
		if name then
			b_type=b_type or "Other"
			if hedlib.enrage[spellId] then b_type="Enrage" end
			if debuffs[b_type] then
				return true
			end
		end
	end
	return nil
end


--[[lib.UpdateAura = function(spell)
	if cfg.aura[spell] then
		hedlib.shallowCopy(cfg.aura[spell],auras_old)
		if cfg.aura[spell].powerType=="debuff" then
			atype="HARMFUL"
		else
			atype="HELPFUL"
		end
		if cfg.aura[spell].caster=="player" then
			atype=atype.." PLAYER"
		end
		found=nil
		for i=1,40 do
			aname, _, _, acount, _, aduration, aexpirationTime, aunitCaster, _, _, aid = UnitAura(cfg.aura[spell].unit,i,atype)
			if cfg.aura[spell].id==aid then
				cfg.aura[spell].duration=aduration
				cfg.aura[spell].expire=aexpirationTime
				cfg.aura[spell].stacks=acount or 1
				cfg.aura[spell].present=1
				if cfg.aura[spell].stacks==0 then cfg.aura[spell].stacks=1 end
				found=true
				break
			end
		end
		if not found then
			cfg.aura[spell].duration=0
			cfg.aura[spell].expire=0
			cfg.aura[spell].stacks=0
			cfg.aura[spell].present=0
		end

		lib.IsAuraChanged(cfg.aura[spell],auras_old)
	end
	return nil
end]]

lib.AuraInTime = function (spell , mint, maxt)
	if not cfg.aura[spell] then return nil end
	if cfg.aura[spell].faded >= mint and cfg.aura[spell].faded <=maxt then
		return true
	else
		return nil
	end
end

lib.GetAuraLastTime = function (spell)
	if cfg.aura[spell] then
		return cfg.aura[spell].faded
	end
	return 0
end

lib.GetAuraLastTimeStacks = function (spell)
	if cfg.aura[spell] then
		return cfg.aura[spell].pstacks
	end
	return 0
end

lib.GetAuraId = function (spell)
	if cfg.aura[spell] then
		return cfg.aura[spell].id
	end
	return "noaura"
end

local tl_aura,tl_caura
-- options = any,min,max
lib.GetAura = function(auras,option) 
	option=option or "any"
	tl_aura = 0
	for _,n_aura in ipairs(auras) do
		if cfg.aura[n_aura] and cfg.aura[n_aura].present==1 then
			tl_caura = (cfg.aura[n_aura].duration==0 and 9999 or math.max(0,cfg.aura[n_aura].expire-GetTime()))
			if tl_caura>0 then 
				if option=="max" then
					tl_aura=math.max(tl_aura,tl_caura)
				elseif option=="min" then
					if tl_aura==0 then
						tl_aura=tl_caura
					else
						tl_aura=math.min(tl_aura,tl_caura)
					end
				else
					return tl_caura
				end
			end
		end
	end
	return tl_aura
end

lib.GetAuraCaster = function(aura,option)
	if lib.GetAura({aura},option)>0 then
		return cfg.aura[aura].real_caster
	else
		return nil
	end
end

local i_aura
--[[lib.GetAuras = function(aura)
	tl_aura = 0
	i_aura=1
	notfound_aura=true
	while notfound_aura do
		n_aura=aura..i_aura
		if cfg.aura[n_aura] then
			if cfg.aura[n_aura].present==1 then
				tl_aura = (cfg.aura[n_aura].duration==0 and 9999 or math.max(0,cfg.aura[n_aura].expire-GetTime())
				if tl_aura>0 then 
					notfound_aura=false
					return tl_aura
				end
			end
			i_aura=i_aura+1
		else
			notfound_aura=false
			return 0
		end
	end
	return 0
end]]

local auras={}
lib.GetAuras = function(aura,option)
	option = option or "max"
	if cfg.auras[aura] then
		return lib.GetAura(cfg.auras[aura],option)
	else
		return 0
	end
end

lib.GetAuraIcon = function(aura)
	if cfg.aura[aura] then return cfg.aura[aura].icon end
	icon=(select(3,GetSpellInfo(aura)))
	return icon
end

lib.HasAuras = function(aura)
	i_aura=1
	notfound_aura=true
	while notfound_aura do
		n_aura=aura..i_aura
		if cfg.aura[n_aura] then
			if cfg.aura[n_aura].present==1 then 
				return true
			end
			i_aura=i_aura+1
		else
			notfound_aura=nil
		end
	end
	return nil
end

--[[lib.IsAura = function(auras)
	if lib.GetAura(auras)>0 then
		return 1
	else
		return 0
	end
end]]

-- lib.GetShortestAura = function(auras)
	-- tl_aura=99999
	-- for _,n_aura in ipairs(auras) do
		-- if cfg.aura[n_aura] then
			-- tl_caura=cfg.aura[n_aura].expire-GetTime()
			-- tl_caura = (tl_caura>=0) and tl_caura or 0
			-- if tl_caura<tl_aura then tl_aura=tl_caura end
		-- end
	-- end
	-- if tl_aura==99999 then return 0 end
	-- return tl_aura
-- end

-- lib.GetLargestAura = function(auras)
	-- tl_aura=0
	-- for _,n_aura in ipairs(auras) do
		-- if cfg.aura[n_aura] then
			-- tl_caura=cfg.aura[n_aura].expire-GetTime()
			-- tl_caura = (tl_caura>=0) and tl_caura or 0
			-- if tl_caura>tl_aura then tl_aura=tl_caura end
		-- end
	-- end
	-- return tl_aura
-- end

-- lib.GetLargestNumber = function(numbers)
	-- bignumber=0
	-- for _,n_num in ipairs(numbers) do
		-- if n_num>bignumber then bignumber=n_num end
	-- end
	-- return bignumber
-- end

local tl_aura
lib.GetAuraStacks = function(aura)
	if cfg.aura[aura] then
		tl_aura=math.max(0,cfg.aura[aura].expire-GetTime())
		if cfg.aura[aura].present==1 and tl_aura==0 then tl_aura=99999 end
		if tl_aura>0 then return (cfg.aura[aura].stacks) end
	end
	return 0
end

lib.UpdateWeaponBuffs = function()
	pMain, pOff = cfg.Weapons.Main, cfg.Weapons.Off
	cfg.Weapons.Main, _, _, cfg.Weapons.Off = GetWeaponEnchantInfo()
	if pMain~=cfg.Weapons.Main or pOff~=cfg.Weapons.Off then return true end
	return false
end

lib.AddDispellTarget = function(spell,spellids,types,rune)
	if rune then
		lib.AddRuneSpell(spell,spellids,rune)
	else
		lib.AddSpell(spell,spellids)
	end
	if cfg.spells[spell] then
		cfg.watchunits["target"]=true
		for _,n_type in ipairs(types) do
			cfg.dispell["target"].powerType[n_type]=true
		end
		cfg.dispell["target"].spell=spell
		cfg.dispell["target"].enabled=true
		cfg.case[spell] = function()
			if cfg.dispell["target"].enabled and cfg.dispell["target"].now then
				return lib.SimpleCDCheck(spell)
			end
			return nil
		end
	end
end

lib.AddDispellPlayer = function(spell,spellids,types)
	lib.AddSpell(spell,spellids)
	if cfg.spells[spell] then
		cfg.watchunits["player"]=true
		for _,n_type in ipairs(types) do
			cfg.dispell["player"].powerType[n_type]=true
		end
		cfg.dispell["player"].spell=spell
		cfg.dispell["player"].enabled=true
		cfg.case[spell] = function()
			if cfg.dispell["player"].enabled and cfg.dispell["player"].now then
				return lib.SimpleCDCheck(spell)
			end
			return nil
		end
	end
end

lib.AddDispell = function(spell,spellids,types,unit)
	lib.AddSpell(spell,spellids)
	if cfg.spells[spell] then
		cfg.watchunits[unit]=true
		for _,n_type in ipairs(types) do
			cfg.dispell[unit].powerType[n_type]=true
		end
		cfg.dispell[unit].spell=spell
		cfg.dispell[unit].enabled=true
		cfg.case[spell] = function()
			if cfg.dispell[unit].enabled and cfg.dispell[unit].now then
				return lib.SimpleCDCheck(spell)
			end
			return nil
		end
	end
end


lib.PrintAuraId = function(id)
	for i=1,40 do
		local name, _, icon, count, type, duration, exp, unitCaster, isStealable, _, spellId=UnitBuff("player",i);
		if name then
			if id==spellId then
				type=debuffType or "other";
				print(i.." "..unitCaster.." "..type.." "..count.." "..name.." = "..spellId.." "..lib.GetAura({cfg.id2aura[id]}))
			end
		--else
			--print(i.." no aura")
		end
	end
end

lib.PrintBuff = function(unit, bufftype)
	unit=unit or "player"
	bufftype=bufftype or "all"
	for i=1,40 do
		local name, _, icon, count, b_type, duration, b_exp, caster, stealable, _, spellId=UnitAura(unit,i)
		if name then
			if count==0 then count=1 end
			b_type=b_type or "Other"
			if hedlib.enrage[spellId] then b_type="Enrage" end
			if b_type==bufftype or bufftype=="all" then
				tmp=name
				tmp=tmp.." ("..spellId..") "
				tmp=tmp..b_type
				tmp=tmp.." count="..count
				tmp=tmp.." left="..(duration==0 and 9999 or math.max(0,b_exp-GetTime()))
				tmp=tmp.." duration="..duration
				tmp=tmp.." expire="..b_exp
				tmp=tmp.." caster="..(caster or "unknown")
				print(tmp)
			end
		end
	end
end

lib.PrintAura = function(spell)
	if cfg.aura[spell] then
		tmp=cfg.aura[spell].name
		tmp=tmp.." ("..cfg.aura[spell].id..") "
		tmp=tmp..cfg.aura[spell].powerType
		tmp=tmp.." on "..cfg.aura[spell].unit
		tmp=tmp.." caster "..cfg.aura[spell].caster
		tmp=tmp.." stacks="..cfg.aura[spell].stacks
		tmp=tmp.." left="..(cfg.aura[spell].duration==0 and 9999 or math.max(0,cfg.aura[spell].expire-GetTime()))
		tmp=tmp.." start="..(cfg.aura[spell].expire-cfg.aura[spell].duration)
		tmp=tmp.." duration="..cfg.aura[spell].duration
		tmp=tmp.." expire="..cfg.aura[spell].expire
		print(tmp)
	end
end


lib.PrintAuras = function(aura)
	local n_aura
	print(aura.." "..lib.GetAuras(aura))
	for _,n_aura in ipairs(cfg.auras[aura]) do
		print(n_aura.." - "..cfg.aura[n_aura].id.." "..cfg.aura[n_aura].name.." "..lib.GetAura({n_aura}))
	end
end